--- putty-src.orig/WINDOWS/WINDOW.C	2011-03-03 02:52:03 +0800
+++ putty-src/WINDOWS/WINDOW.C	2011-11-04 20:55:10 +0800
@@ -202,6 +202,27 @@
 
 static UINT wm_mousewheel = WM_MOUSEWHEEL;
 
+/* convert to unicode for SetWindowText */
+static void my_SetWindowText(HWND hwnd, char *title)
+{
+    if (term->ucsdata->line_codepage != CP_ACP) {
+        int len, rc;
+        char *p;
+
+        len = MultiByteToWideChar(term->ucsdata->line_codepage, 0, title, -1, NULL, 0);
+        p = snewn(1 + len *  2, char);
+        rc = MultiByteToWideChar(term->ucsdata->line_codepage, 0, title, -1 , (LPWSTR)p, len*2);
+        if (rc != len)
+            SetWindowText(hwnd, title);
+        else
+            SetWindowTextW(hwnd, p);
+        sfree(p);
+    }
+    else
+        SetWindowText(hwnd, title);
+    return;
+}
+
 /* Dummy routine, only required in plink. */
 void ldisc_update(void *frontend, int echo, int edit)
 {
@@ -2254,7 +2275,7 @@
 
 		set_title(NULL, cfg.wintitle);
 		if (IsIconic(hwnd)) {
-		    SetWindowText(hwnd,
+		    my_SetWindowText(hwnd,
 				  cfg.win_name_always ? window_name :
 				  icon_name);
 		}
@@ -2772,10 +2793,10 @@
 	    LOWORD(lParam), HIWORD(lParam)));
 #endif
 	if (wParam == SIZE_MINIMIZED)
-	    SetWindowText(hwnd,
+	    my_SetWindowText(hwnd,
 			  cfg.win_name_always ? window_name : icon_name);
 	if (wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED)
-	    SetWindowText(hwnd, window_name);
+	    my_SetWindowText(hwnd, window_name);
         if (wParam == SIZE_RESTORED) {
             processed_resize = FALSE;
             clear_full_screen();
@@ -4524,7 +4545,7 @@
     window_name = snewn(1 + strlen(title), char);
     strcpy(window_name, title);
     if (cfg.win_name_always || !IsIconic(hwnd))
-	SetWindowText(hwnd, title);
+	my_SetWindowText(hwnd, title);
 }
 
 void set_icon(void *frontend, char *title)
@@ -4533,7 +4554,7 @@
     icon_name = snewn(1 + strlen(title), char);
     strcpy(icon_name, title);
     if (!cfg.win_name_always && IsIconic(hwnd))
-	SetWindowText(hwnd, title);
+	my_SetWindowText(hwnd, title);
 }
 
 void set_sbar(void *frontend, int total, int start, int page)
